#!/bin/bash
# Converte file di testo in pdf utilizzando "enscript" e "ps2pdf"
# Scritto il 27 giugno 2012 da Giovanni Ubaldi http://www.ubaweb.it/miniguide/
# aggiornato il 1 luglio 2012 (inserito u2ps per covertire file UTF-8
# richiede 'enscript' e '''
# USO:
# Dopo aver reso eseguibile lo script con chmod +x txt2pdf.sh
# Se lo script è in una directory contenuta nella variabile $PATH digitare:
# txt2pdf.sh file_di_testo_da_convertire 		
# se lo script NON è nel $PATH: dalla directory che contiene lo script digitare:
# ./txt2pdf.sh file_di_testo_da_convertire 
# mettere tra virgolette il nome e percorso del file se contengono spazi.
# LO SCRIPT 'SECCO'
# Nelle righe da 15 a 19 c'è la versione 'essenziale' dello script (non UTF-8)
# nomefile=$1 # $1 se passato come argomento altrimenti inserire il 'nome_del_file_di_testo'
# enscript "$nomefile" -q -p $nomefile.ps
# ps2pdf $nomefile.ps $nomefile.pdf
# rm -f $nomefile.ps
# exit

clear
if [ "$1" != '' ];then
		file_resoconto="$1"
		else
		echo  -e "Non hai inserito il parametro contenente il nome del file da convertire\n
(inserire anche il percorso se lo script è eseguito da una directory diversa
 da quella del file di testo).\n
Non è un problema! 8-) Digitalo, poi premi Invio:
"
read file_resoconto

fi


if [ -r "$file_resoconto" ];then
		file_noext=${file_resoconto%%.*}	#rimuovo l'estensione
		:
		# echo -e "\nIl file di testo sarà salvato come $file_noext.pdf\n"
	else
		echo -e "\n\t8-| Attenzione il file $file_resoconto non esiste,\n\tnon è leggibile\n\toppure\n\t il percorso al file non è corretto! 8-|"
		exit 1
fi

		# verifica programmi
		path_enscript=$(which "enscript")
		if [ "$path_enscript" == "" ]
			then
			echo '8-| Attenzione "enscript" non risulta installato! 8-|'
			exit 1
		fi
		
		path_u2ps=$(which "u2ps")
		if [ "$path_u2ps" == "" ]
			then
			echo '8-| Attenzione "u2ps" non risulta installato! 8-|'
			exit 1
		fi
		
		path_ps2pdf=$(which "ps2pdf")
		if [ "$path_ps2pdf" == '' ];then
			echo '8-| Attenzione "ps2pdf" non risulta installato! 8-|'
			exit 1
		fi

ver_utf8="UTF-8 Unicode"
codifica=$(file -b "$file_resoconto")
utf=$(echo $codifica | grep -c "$ver_utf8")

# Conversione in ps

if [  "$utf" == "0" ];then 
		echo -e "Attenzione! Il file $file_resoconto non è $ver_utf8 ma risulta essere \"$codifica\"\n.
Caratteri come, per esempio, il simbolo dell'euro \"€\",\nnon saranno stampati correttamente!\n
In questo caso chiudere il programma, convertire il file in UTF-8 e poi esegure txt2pdf.\n
Altrimenti se non sono presenti caratteri problematici proseguire l'esecuzione del programma.\n"
		echo 'Creo ugualmente la versione PDF? ("S"= Si, confermo!, "Invio"= Esci!)'

		read -n 1 pdf
		if [[ ($pdf != 's') && ($pdf != 'S') ]];then
		exit
		fi
		
		enscript --header='$n del %F||Pagina $% di $=' "$file_resoconto" -p "$file_noext".ps 2> /dev/null
		# -p:output su file
		# --header='sinistra|centro|destra'
		# $n:nome del file;%F:data dd.mm.yyyy||$%:pagina corrente; $=:totale pagine
		
		#verifica esecuzione
		if [ "$?" != "0" ];then
			echo -e "\n8-( Spicente non è stato possibile convertire il file di testo in ps 8-("
			exit 1
		fi
	else
		$path_u2ps -t "$file_noext" -o $file_noext.ps $file_resoconto 2> /dev/null
		# -t: titolo
		# -o: output su file
		
fi

		
# Conversione in pdf		
		ps2pdf $file_noext.ps $file_noext.pdf
		#verifica esecuzione
    if [ "$?" != "0" ];then
			echo -e "\n8-( Spicente non è stato possibile convertire il file in pdf 8-("
			# exit 1  # decommentare se NON si vuole cancellare il file .ps
        else
			clear
        	echo -e "\n\n\t 8-) Ok! Creato $file_noext.pdf 9-)\n Ciao\n\n"
    fi
	
		rm -f "$file_noext".ps
		
	if [ "$?" != "0" ];then
        echo -e "\n8-( Non è stato possibile cancellare $file_noext.ps, 8-("
        exit 1
    fi	

exit 0

exit 0
